-- ScriptContextTooltipCompare.lua
-- Script for Context Tooltip Compare addon
-- 17:04 12.01.2009
--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------
Global( "onBase", {} )
--------------------------------------------------------------------------------
--EVENT HANDLERS
--------------------------------------------------------------------------------
onBase[ "SCRIPT_REQUEST_CONTEXT_COMPARE_TOOLTIP" ] = function( params )
	tooltip:Toggle( false )
	
	params = Normalize( params )
	params.itemId = GetCompareItemId( params.itemId )
	
	if params.itemId then
		params[ 1 ] = { type = TOOLTIP_CONTENT.SMART_LINE, { value = GetText( "Equipped" ), style = "tip_golden" } }
		params[ 2 ] = { type = TOOLTIP_CONTENT.SEPARATOR, { active = true } }
	
		local content = MergeContent( GetTemplateContent( params ), GetCustomContent( params ) )

		if content then
			tooltip:Repaint( content )
			tooltip:SetupUpdate( content, params, onBase.SCRIPT_REQUEST_CONTEXT_TOOLTIP )
			tooltip:Place( GetCompareTooltipRect( params ) )
			tooltip:Toggle( true, params )
		end
	end
end
--------------------------------------------------------------------------------
onBase[ "SCRIPT_HIDE_CONTEXT_COMPARE_TOOLTIP" ] = function( params )
	tooltip:Toggle( false, params )
end
--------------------------------------------------------------------------------
--MAIN FUNCTIONS
--------------------------------------------------------------------------------
function GetCompareItemId( id )
	local itemId = nil
	if id then
		local itemInfo = avatar.GetItemInfo( id )
		--trace( "itemInfo = ", itemInfo )
		if itemInfo then
			if itemInfo.dressSlot ~= DRESS_SLOT_UNDRESSABLE then
				--trace( "itemInfo.dressSlot = ", itemInfo.dressSlot, ", ", strDressSlotId[ itemInfo.dressSlot ] )
				-- /// @todo    (, RING)   (, RING1, RING2) 
				--    (, -,   2 )
				if itemInfo.dressSlot == DRESS_SLOT_TWOHANDED or
					itemInfo.dressSlot == DRESS_SLOT_DUALWIELD then
					
					itemInfo.dressSlot = DRESS_SLOT_MAINHAND
					
				elseif itemInfo.dressSlot == DRESS_SLOT_RING then
					itemInfo.dressSlot = DRESS_SLOT_RING1
				end
				
				--trace( "itemInfo.dressSlot = ", itemInfo.dressSlot, ", ", strDressSlotId[ itemInfo.dressSlot ] )
				local avatarId = avatar.GetId()
				itemId = unit.GetEquipmentItemId( avatarId, itemInfo.dressSlot )
				
				if itemId == id then
					itemId = nil
				end
			end
		end
	end
	return itemId
end
--------------------------------------------------------------------------------
function GetCompareTooltipRect( params )
	if params.ttrect then
		if params.rect then
			params.rect.x1 = math.min( params.rect.x1, params.ttrect.x1 )
			params.rect.x2 = math.max( params.rect.x2, params.ttrect.x2 )
			params.rect.y1 = math.min( params.rect.y1, params.ttrect.y1 )
			params.rect.y2 = math.max( params.rect.y2, params.ttrect.y2 )
		else
			params.rect = params.ttrect
		end
	end
	return params
end
--------------------------------------------------------------------------------
--INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	RegisterLayoutManagedAddon( { type = ADDON_TYPE_SUPER_HUD, side = SCREEN_SIDE_GENERAL } )
	multevent.RegisterEventHandlers( onBase )
	tooltipcontent:Init()
	tooltip:Init()
end
--------------------------------------------------------------------------------
Init()