-- ScriptContextTooltip.lua
-- Script for Context Tooltip addon
-- 17:56 07.01.2009
--------------------------------------------------------------------------------
--trace.enable()
--trace.include( tooltip, templates[ TOOLTIP_INNATE_STAT ] )
--trace.include( Normalize, MergeContent, GetTemplateContent, GetCustomContent )
--trace.filter( TableStringFilter )
--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------
Global( "onBase", {} )
--------------------------------------------------------------------------------
function AppendShortcut( content, sysSectionName, sysBindName )
	local bind = binding.GetBind( sysSectionName, sysBindName )
	
	table.insert( content, { type = TOOLTIP_CONTENT.SEPARATOR, { active = true } } )
	
	for id, key in bind.keys do
		table.insert( content, {
			type = TOOLTIP_CONTENT.SMART_LINE,
			{
				format = GetText( "HotKey" ),
				value = key, style = "tip_golden" }
			}
		)
	end
end
--------------------------------------------------------------------------------
--EVENT HANDLERS
--------------------------------------------------------------------------------
onBase[ "SCRIPT_REQUEST_CONTEXT_TOOLTIP" ] = function( params )
	tooltip:Toggle( false )
	
	params = Normalize( params )
	local content = MergeContent( GetTemplateContent( params ), GetCustomContent( params ) )
	
	if content then
		if params.shortcut then
			AppendShortcut( content, params.shortcut.sysSectionName, params.shortcut.sysBindName )
		end
		
		tooltip:Repaint( content )
		tooltip:SetupUpdate( content, params, onBase.SCRIPT_REQUEST_CONTEXT_TOOLTIP )
		tooltip:Place( params )
		tooltip:Toggle( true, params )
	end
	
	local compare = Clone( params )
	compare.shortcut = nil
	
	if params.tooltip == TOOLTIP_ITEM
	or params.tooltip == TOOLTIP_ITEM_VENDOR then
		compare.tooltip = TOOLTIP_ITEM
		
		compare.ttrect = tooltip.widget:GetRealRect()
	end
	
	if params.tooltip == TOOLTIP_ITEM
	or params.tooltip == TOOLTIP_ITEM_VENDOR then
		common.SendEvent( "SCRIPT_REQUEST_CONTEXT_COMPARE_TOOLTIP", compare )
	else
		common.SendEvent( "SCRIPT_HIDE_CONTEXT_COMPARE_TOOLTIP", compare )
	end
end
--------------------------------------------------------------------------------
onBase[ "SCRIPT_HIDE_CONTEXT_TOOLTIP" ] = function( params )
	tooltip:Toggle( false, params )
	
	local compare = Clone( params )
	if params.tooltip == TOOLTIP_ITEM
	or params.tooltip == TOOLTIP_ITEM_VENDOR then
		compare.tooltip = TOOLTIP_ITEM
	end
	
	common.SendEvent( "SCRIPT_HIDE_CONTEXT_COMPARE_TOOLTIP", compare )
end
--------------------------------------------------------------------------------
--INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	RegisterLayoutManagedAddon( { type = ADDON_TYPE_SYSTEM, side = SCREEN_SIDE_NONE } )
	multevent.RegisterEventHandlers( onBase )
	tooltipcontent:Init()
	tooltip:Init()
end
--------------------------------------------------------------------------------
Init()