-- ScriptContextTooltipCore.lua
-- Script for Core Functions of Context Tooltip addon
-- 16:44 12.01.2009
--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------
Global( "PROGRESS_BAR_LENGTH", 312 )
Global( "sysWtAlignId", {
	[ WIDGET_ALIGN_LOW ] = "WIDGET_ALIGN_LOW",
	[ WIDGET_ALIGN_HIGH ] = "WIDGET_ALIGN_HIGH",
	[ WIDGET_ALIGN_CENTER ] = "WIDGET_ALIGN_CENTER",
	[ WIDGET_ALIGN_BOTH ] = "WIDGET_ALIGN_BOTH",
	[ WIDGET_ALIGN_LOW_ABS ] = "WIDGET_ALIGN_LOW_ABS"
} )
Global( "sysWtSizingId", {
	[ WIDGET_SIZING_CHILDREN ] = "WIDGET_SIZING_CHILDREN",
	[ WIDGET_SIZING_DEFAULT ] = "WIDGET_SIZING_DEFAULT",
	[ WIDGET_SIZING_INTERNAL ] = "WIDGET_SIZING_INTERNAL"
} )
Global( "sysTooltipContentId", {} )
for id, value in TOOLTIP_CONTENT do
	sysTooltipContentId[ value ] = "TOOLTIP_CONTENT_" .. id
end
Global( "sysItemBindingId", {
	[ ITEM_BINDING_BIND_NONE ] = "ITEM_BINDING_BIND_NONE",
	[ ITEM_BINDING_BIND_ON_PICKUP ] = "ITEM_BINDING_BIND_ON_PICKUP",
	[ ITEM_BINDING_BIND_ON_EQUIP ] = "ITEM_BINDING_BIND_ON_EQUIP",
	[ ITEM_BINDING_BIND_ON_USE ] = "ITEM_BINDING_BIND_ON_USE"
} )
Global( "sysReputationLevelId", {
	[ REPUTATION_LEVEL_HOSTILITY ] = "REPUTATION_LEVEL_HOSTILITY",
	[ REPUTATION_LEVEL_ENEMY ] = "REPUTATION_LEVEL_ENEMY",
	[ REPUTATION_LEVEL_UNFRIENDLY ] = "REPUTATION_LEVEL_UNFRIENDLY",
	[ REPUTATION_LEVEL_NEUTRAL ] = "REPUTATION_LEVEL_NEUTRAL",
	[ REPUTATION_LEVEL_KINDLY ] = "REPUTATION_LEVEL_KINDLY",
	[ REPUTATION_LEVEL_FRIENDLY ] = "REPUTATION_LEVEL_FRIENDLY",
	[ REPUTATION_LEVEL_CONFIDENTIAL ] = "REPUTATION_LEVEL_CONFIDENTIAL"
} )
Global( "sysHonorRankId", {
	[ HONOR_RANK_NONE ] = "HONOR_RANK_NONE",
	[ HONOR_RANK_WHIPPERSNAPPER ] = "HONOR_RANK_WHIPPERSNAPPER",
	[ HONOR_RANK_KILLER ] = "HONOR_RANK_KILLER",
	[ HONOR_RANK_BUTCHER ] = "HONOR_RANK_BUTCHER",
	[ HONOR_RANK_JUDGE ] = "HONOR_RANK_JUDGE"
} )
Global( "sysInnateStatsId", {
	[ INNATE_STAT_STRENGTH ] = "INNATE_STAT_STRENGTH", --
	[ INNATE_STAT_MIGHT ] = "INNATE_STAT_MIGHT", --
	[ INNATE_STAT_DEXTERITY ] = "INNATE_STAT_DEXTERITY", --
	[ INNATE_STAT_AGILITY ] = "INNATE_STAT_AGILITY", --
	[ INNATE_STAT_STAMINA ] = "INNATE_STAT_STAMINA", -- 
	[ INNATE_STAT_PRECISION ] = "INNATE_STAT_PRECISION", -- 
	[ INNATE_STAT_HARDINESS ] = "INNATE_STAT_HARDINESS", --
	[ INNATE_STAT_INTELLECT ] = "INNATE_STAT_INTELLECT", --
	[ INNATE_STAT_INTUITION ] = "INNATE_STAT_INTUITION", --
	[ INNATE_STAT_SPIRIT ] = "INNATE_STAT_SPIRIT", --
	[ INNATE_STAT_WILL ] = "INNATE_STAT_WILL", --
	[ INNATE_STAT_RESOLVE ] = "INNATE_STAT_RESOLVE", --
	[ INNATE_STAT_WISDOM ] = "INNATE_STAT_WISDOM", --
	[ INNATE_STAT_LETHALITY ] = "INNATE_STAT_LETHALITY" --
} )
Global( "tooltipcontent", {
	[ TOOLTIP_CONTENT.SMART_LINE ] = { list = {}, name = "SmartLine", id = TOOLTIP_CONTENT.SMART_LINE },
	[ TOOLTIP_CONTENT.ICON_SMART_LINE ] = { list = {}, name = "IconSmartLine", id = TOOLTIP_CONTENT.ICON_SMART_LINE },
	[ TOOLTIP_CONTENT.RUNE_INFO_LINE ] = { list = {}, name = "RuneInfoLine", id = TOOLTIP_CONTENT.RUNE_INFO_LINE },
	[ TOOLTIP_CONTENT.DOUBLE_LINE ] = { list = {}, name = "DoubleLine", id = TOOLTIP_CONTENT.DOUBLE_LINE },
	[ TOOLTIP_CONTENT.ICON_BAR ] = { list = {}, name = "CraftingComponents", id = TOOLTIP_CONTENT.ICON_BAR },
	[ TOOLTIP_CONTENT.MONEY_COUNT ] = { list = {}, name = "MoneyCount", id = TOOLTIP_CONTENT.MONEY_COUNT },
	[ TOOLTIP_CONTENT.PROGRESS_BAR ] = { list = {}, name = "ProgressBar", id = TOOLTIP_CONTENT.PROGRESS_BAR },
	[ TOOLTIP_CONTENT.SEPARATOR ] = { list = {}, name = "Separator", id = TOOLTIP_CONTENT.SEPARATOR }
} )
Global( "tooltip", {
	handlers = {}
} )
Global( "templates", {
	[ TOOLTIP_NONE ] = { sysId = "TOOLTIP_NONE", params = {} },
	[ TOOLTIP_UNIT ] = { sysId = "TOOLTIP_UNIT", params = { "unitId" } },
	[ TOOLTIP_ITEM ] = { sysId = "TOOLTIP_ITEM", params = { "itemId" } },
	[ TOOLTIP_ITEM_VENDOR ] = { "TOOLTIP_ITEM_VENDOR", params = { "itemId" } },
	[ TOOLTIP_MAPMARK ] = { sysId = "TOOLTIP_MAPMARK", params = {} },
	[ TOOLTIP_SPELL ] = { sysId = "TOOLTIP_SPELL", params = { "spellId" } },
	[ TOOLTIP_BUFF ] = { sysId = "TOOLTIP_SPELL", params = { "unitId", "index" } },
	[ TOOLTIP_ABILITY ] = { sysId = "TOOLTIP_ABILITY", params = { "abilityId" } },
	[ TOOLTIP_COMPONENT ] = { sysId = "TOOLTIP_COMPONENT", params = { "componentId" } },
	[ TOOLTIP_RECIPE ] = { sysId = "TOOLTIP_RECIPE", params = { "recipeId" } },
	[ TOOLTIP_USABLE_DEVICE ] = { sysId = "TOOLTIP_USABLE_DEVICE", params = { "name" } },
	[ TOOLTIP_ASTRAL_UNIT ] = { sysId = "TOOLTIP_ASTRAL_UNIT", params = { "unitId" } },
	[ TOOLTIP_FAIRY ] = { sysId = "TOOLTIP_FAIRY", params = { "unitId" } },
	[ TOOLTIP_SIMPLE ] = { sysId = "TOOLTIP_SIMPLE", params = { "name" } },
	[ TOOLTIP_SIMPLEDESC ] = { sysId = "TOOLTIP_SIMPLEDESC", params = { "name", "desc" } },
	[ TOOLTIP_TALENT ] = { sysId = "TOOLTIP_TALENT", params = { "row", "column" } },
	[ TOOLTIP_REPUTATION ] = { sysId = "TOOLTIP_REPUTATION", params = { "faction" } },
	[ TOOLTIP_HEARTHSTONE ] = { sysId = "TOOLTIP_HEARTHSTONE", params = {} },
	[ TOOLTIP_INNATE_STAT ] = { sysId = "TOOLTIP_INNATE_STAT", params = { "statId" } }
} )
Global( "icons", { list = {}, name = "Icon" } )
--------------------------------------------------------------------------------
-- COMMON UTILITY
--------------------------------------------------------------------------------
function TableStringFilter( id, value )
	local valtype = type( value )
	
	if valtype == "number" then
		if id == "tooltip" then return templates[ value ] and templates[ value ].sysId end
		if id == "dressSlot" then return strDressSlotId[ value ] end
		if id == "binding" then return sysItemBindingId[ value ] end
		if id == "requiredHonorRank" then return sysHonorRankId[ value ] end
		if id == "requiredReputationLevel" then return sysReputationLevelId[ value ] end
		if id == "type" then return sysTooltipContentId[ value ] end
		if id == "alignX" or id == "alignY" then return sysWtAlignId[ value ] end
		if id == "sizingX" or id == "sizingY" then return sysWtSizingId[ value ] end
		if id == "statId" then return sysInnateStatsId[ value ] end
	
	elseif valtype == "string" then
		return "\"" .. value .. "\""
	
	elseif valtype == "userdata" then
		if id == "widget"
		or HasNamePrefix( tostring( id ), "wt" ) then
			return "widget: \"" .. value:GetName() .. "\""
		end
		
		if id == "spellId" then
			local spellInfo = avatar.GetSpellInfo( value )
			return spellInfo and ( "spell: \"" .. spellInfo.debugName .."\"" ) or "NO_SPELL_INFO"
		end
		
		if id == "abilityId" then
			local abilityInfo = avatar.GetAbilityInfo( value )
			return abilityInfo and ( "ability: \"" .. abilityInfo.sysInfo .."\"" ) or "NO_ABILITY_INFO"
		end
	end
end
--------------------------------------------------------------------------------
function GetNameFromInfo( params, info )
	local name = {
		format = GetText( "Header" ),
		style = "tip_white",
		value = ValidateWs( params.name or ( info and info.name ) )
	}
	return name
end
--------------------------------------------------------------------------------
function GetDescFromInfo( params, info )
	local desc = params.desc or ( info and info.description )
	
	if IsValidTextValue( desc ) then
		desc = {
			format = GetText( "Default" ),
			style = "tip_golden",
			multiline = true,
			value = desc
		}
	else
		desc = nil
	end

	return desc
end
--------------------------------------------------------------------------------
function ReprocessColor( color )
	local result = {}
	for i, c in color do result[ i ] = c / 255 end
	return result
end
--------------------------------------------------------------------------------
-- TOOLTIP
--------------------------------------------------------------------------------
tooltip.Init = function( self )
	self:GetWidgets()
	self:Toggle( false )
	self.defaultPlacement = self.widget:GetPlacementPlain()
end
--------------------------------------------------------------------------------
tooltip.GetWidgets = function( self )
	self.widget = mainForm:GetChildChecked( "Tooltip", false )
	self.container = self.widget:GetChildChecked( "Container", false )
	self.widget:Show( false )
end
--------------------------------------------------------------------------------
tooltip.Clear = function( self )
	self.container:RemoveItems()
	
	for id, value in ipairs( tooltipcontent ) do
		value:Clear()
	end

	multevent.UnRegisterEventHandlers( self.handlers )
	self.handlers = {}
end
--------------------------------------------------------------------------------
tooltip.Toggle = function( self, state, request )
	--trace( "request = ", request )
	--trace( "self.request = ", self.request )
	
	if request then
		request.event = nil
	end
	
	local permission = true
	if request and self.request then
		permission = IsEqual( request, self.request )
	end
	--trace( "permission = ", permission )
	
	if self.toggled ~= state
	and permission then
		self.toggled = state
		self.widget:Show( state )
		self.request = state and request or nil
	end
	
	if not state
	and permission then
		self:Clear()
	end
end
--------------------------------------------------------------------------------
tooltip.Repaint = function( self, content )
	for id, entry in pairs( content ) do
		if type( id ) == "number" then
			self:Add( entry )
		end
	end
end
--------------------------------------------------------------------------------
tooltip.Place = function( self, params )
	local placement = self.widget:GetPlacementPlain()
	--trace( "placement = ", placement )

	if params.rect then
		--trace( "params.rect = ", params.rect )
		
		local rect = self.widget:GetRealRect()
		rect.sizeX = rect.x2 - rect.x1
		rect.sizeY = rect.y2 - rect.y1
		--trace( "rect = ", rect )
	
		local frameRect = mainForm:GetRealRect()
		frameRect.sizeX = frameRect.x2 - frameRect.x1
		frameRect.sizeY = frameRect.y2 - frameRect.y1
		--trace( "frameRect = ", frameRect )

		local placeX = frameRect.x2 - params.rect.x2
		local placeY = frameRect.y2 - params.rect.y1
		--trace( "placeX = ", placeX, ", placeY = ", placeY )
		
		placement.alignX = WIDGET_ALIGN_LOW_ABS
		placement.alignY = WIDGET_ALIGN_LOW_ABS
		
		if placeX > rect.sizeX then
			placement.posX = params.rect.x2
		else
			placement.posX = params.rect.x1 - rect.sizeX
		end
		
		if frameRect.y2 - params.rect.y1 > rect.sizeY then
			placement.posY = params.rect.y1
			
		elseif params.rect.y2 > rect.sizeY then
			placement.posY = params.rect.y2 - rect.sizeY
			
		else
			placement.posY = ( frameRect.sizeY - rect.sizeY ) / 2
		end
		
	else
		placement = self.defaultPlacement
	end
	
	self.widget:SetPlacementPlain( placement )
	--trace( "placement = ", placement )
end
--------------------------------------------------------------------------------
tooltip.Add = function( self, entry )
	local data, type, update = tooltip.SplitEntry( entry )
	
	if type and not IsEmptyTable( data ) then
		local id, set = tooltipcontent[ type ]:GetFree()
		
		set:Repaint( unpack( data ) )
		self.container:PushBack( set.widget )
		set.widget:Show( true )
		
		if update then
			for event, updater in update do
				local GetData = updater
				
				set.handlers[ event ] = function( params )
					local data = { GetData( params ) }
					
					if not IsEmptyTable( data ) then
						set:Repaint( unpack( data ) )
					end
				end
			end
			
			multevent.RegisterEventHandlers( set.handlers )
		end
	end
end
--------------------------------------------------------------------------------
tooltip.SetupUpdate = function( self, content, request, MainHandler )
	local update = content.update or {}
	self.handlers = {}
	
	for event, updater in update do
		local Test = updater
		self.handlers[ event ] = function( params )
			if Test( params ) then
				MainHandler( request )
			end
		end
	end

	multevent.RegisterEventHandlers( self.handlers )
end
--------------------------------------------------------------------------------
-- TOOLTIP UTILITY
--------------------------------------------------------------------------------
tooltip.IsValidEntry = function( entry )
	local result = IsTable( entry )
	
	if IsEmptyTable( entry )
	or not entry.type	then
		result = false
	end
	return result
end
--------------------------------------------------------------------------------
tooltip.SplitEntry = function( entry )
	local type = entry.type
	entry.type = nil
		
	local update = entry.update
	entry.update = nil

	entry.n = table.maxn( entry )
	return entry, type, update
end
--------------------------------------------------------------------------------
-- ADDON
--------------------------------------------------------------------------------
function Normalize( params )
	if params.tooltip then
		if params.tooltip == TOOLTIP_SIMPLEDESC and not params.desc then
			params.tooltip = TOOLTIP_SIMPLE
		end

		for id, param in templates[ params.tooltip ].params do
			if not params[ param ] then
				LogWarning( " tooltip: invalid request type ", templates[ params.tooltip ].sysId, "; ", param, " expected, got nil. Template will be ignored" )
				params.tooltip = nil
				break
			end
		end
		
	else
		if params.name then
			params.tooltip = TOOLTIP_SIMPLE
		end
		
		if params.desc then
			params.tooltip = TOOLTIP_SIMPLEDESC
		end
	end

	return params
end
--------------------------------------------------------------------------------
function GetTemplateContent( params )
	local data = nil
	local custom = nil
	local content = nil
	
	if params.tooltip then
		data = templates[ params.tooltip ]:GetDataFrom( params )
		
		if data then
			content = templates[ params.tooltip ]:AssembleContentFrom( data )
		end
	end
	
	return content
end
--------------------------------------------------------------------------------
function GetCustomContent( params )
	local custom = {}

	for id, value in params do
		if type( id ) == "number" then
			custom[ id ] = value
		end
	end

	custom.update = params.update

	return not IsEmptyTable( custom ) and custom or nil
end
--------------------------------------------------------------------------------
function MergeContent( content, custom )
	content = content or {}
	custom = custom or {}
	local shift = 0
	
	for id, entry in custom do
		table.insert( content, id, entry )
		shift = shift + 1
	end
	
	return not IsEmptyTable( content ) and content or nil
end
--------------------------------------------------------------------------------
-- TOOLTIP CONTENT
--------------------------------------------------------------------------------
tooltipcontent.Init = function( self )
	for id, value in ipairs( self ) do
		value.NewWidget = self.NewWidget
		value.GetFree = self.GetFree
		value.Clear = self.Clear
	end
end
--------------------------------------------------------------------------------
tooltipcontent.NewWidget = function( self )
	local widget = {}
	
	if not self.widgetDesc then
		widget = mainForm:GetChildChecked( self.name, false )
		self.widgetDesc = widget:GetWidgetDesc()
	else
		widget = mainForm:CreateWidgetByDesc( self.widgetDesc )
	end

	return widget
end
--------------------------------------------------------------------------------
tooltipcontent.GetFree = function( self )
	local id, set = SearchInTable( self.list, { isFree = true } )
	--trace( "search: id = ", id, ", set = ", set )
	
	if not id then
		set = self:CreateFrom( self:NewWidget() )
		
		set.Repaint = self.Repaint
		set.Reset = self.Reset
		set.handlers = {}
		
		table.insert( self.list, set )
		id = GetTableSize( self.list )
		set.id = id
		set.name = GetNameByPrefix( set.name, id )
		set.widget:SetName( set.name )
	end
	
	set.isFree = false
	return id, set
end
--------------------------------------------------------------------------------
tooltipcontent.Clear = function( self )
	for contentId, set in self.list do
		if not set.isFree then
			set.widget:Show( false )
			set:Reset()
			multevent.UnRegisterEventHandlers( set.handlers )
			set.handlers = {}
			set.isFree = true
		end
	end
end
--------------------------------------------------------------------------------
-- CREATE FROM WIDGET
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.SMART_LINE ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.name = widget:GetName()
	set.widget:Show( false )

	return set
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.ICON_SMART_LINE ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.wtLabel = widget:GetChildChecked( "SmartLine", false )
	set.wtForeIcon = widget:GetChildChecked( "ForeIcon", false )
	set.wtBackIcon = widget:GetChildChecked( "BackIcon", false )
	set.name = widget:GetName()
	set.widget:Show( false )

	return set
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.RUNE_INFO_LINE ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.wtLabel = widget:GetChildChecked( "Info", false )
	set.wtIcon = widget:GetChildChecked( "Icon", false )
	set.wtLevel = widget:GetChildChecked( "Level", false )
	set.name = widget:GetName()
	set.widget:Show( false )

	return set
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.DOUBLE_LINE ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.name = widget:GetName()
	set.widget:Show( false )
	
	set.wtLeft = set.widget:GetChildChecked( "LineLeft", false )
	set.wtRight = set.widget:GetChildChecked( "LineRight", false )
	return set
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.ICON_BAR ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.name = widget:GetName()
	set.widget:Show( false )
	
	set.container = widget

	return set
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.MONEY_COUNT ].CreateFrom = function( self, widget )
	return money:CreateFrom( widget )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.PROGRESS_BAR ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.name = widget:GetName()
	set.widget:Show( false )
	
	set.wtProgress = set.widget:GetChildChecked( "Progress", false )
	set.wtLabel = set.widget:GetChildChecked( "ProgressBarLabel", false )
	return set
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.SEPARATOR ].CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.name = widget:GetName()
	set.widget:Show( false )

	return set
end
--------------------------------------------------------------------------------
-- UPDATE
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.SMART_LINE ].Repaint = function( self, params )
	params.format = params.format or GetText( "Default" )
	
	if params.background then
		if params.background.color then
			self.widget:SetBackgroundColor( params.background.color )
		end
		params.background = nil
	end
	
	SetupWString( self.widget, params )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.ICON_SMART_LINE ].Repaint = function( self, text, fore, back )
	local foreSize = 20
	local backSize = 20
	
	if fore then
		foreSize = fore.size or foreSize
		fore.icon = fore.icon or GetTexture( "Empty" )
		self.wtForeIcon:SetBackgroundTexture( fore.icon )
	end
	
	if back then
		backSize = back.size or backSize
		back.icon = back.icon or GetTexture( "Empty" )
		self.wtBackIcon:SetBackgroundTexture( back.icon )
	end
	
	local placement = self.wtForeIcon:GetPlacementPlain()
	placement.sizeX = foreSize
	placement.sizeY = foreSize
	self.wtForeIcon:SetPlacementPlain( placement )
	
	placement = self.wtBackIcon:GetPlacementPlain()
	placement.sizeX = backSize
	placement.sizeY = backSize
	self.wtBackIcon:SetPlacementPlain( placement )
	
	self.wtForeIcon:Show( fore ~= nil )
	self.wtBackIcon:Show( back ~= nil )
	
	if text.background then
		if text.background.color then
			self.wtLabel:SetBackgroundColor( text.background.color )
		end
		text.background = nil
	end
	
	text = text or {}
	text.format = text.format or GetText( "Default" )
	SetupWString( self.wtLabel, text )
	
	local posX = fore and foreSize
	local highPosX = back and backSize
	
	--trace( "posX = ", posX, ", highPosX = ", highPosX )
	
	if posX or highPosX then
		--[[local maxWidth = self.wtLabel:GetMaxWidth() - ( posX or 0 ) - ( highPosX or 0 )
		local minWidth = math.clamp( self.wtLabel:GetMinWidth(), nil, maxWidth - 1 )
		self.wtLabel:SetMaxWidth( maxWidth )
		self.wtLabel:SetMinWidth( minWidth )]]
		
		local placement = self.wtLabel:GetPlacementPlain()
		placement.posX = posX and ( posX + 3 ) or 0
		placement.highPosX = highPosX and ( highPosX + 3 ) or 0
		self.wtLabel:SetPlacementPlain( placement )
		--trace( "placement = ", placement )
	end
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.RUNE_INFO_LINE ].Repaint = function( self, info )
	self.wtIcon:SetBackgroundTexture( info.icon or GetTexture( "PlaceholderOrange" ) )

	local placement = self.wtLevel:GetPlacementPlain()
	placement.sizeX = 22 * info.count or 1
	self.wtLevel:SetPlacementPlain( placement )
	
	SetupWString( self.wtLabel, info )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.DOUBLE_LINE ].Repaint = function( self, left, right )
	if left then
		left.multiline = false
		left.format = left.format or GetText( "Default" )
		SetupWString( self.wtLeft, left )
	end
			
	if right then
		right.multiline = false
		right.format = right.format or GetText( "DefaultRight" )
		SetupWString( self.wtRight, right )
	end
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.ICON_BAR ].Repaint = function( self, params )
	for id, texture in params do
		local id, set = icons:GetFree()
		
		set:SetTexture( texture )
		self.container:PushBack( set.widget )
		set.widget:Show( true )
	end
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.MONEY_COUNT ].Repaint = function( self, params )
	self:SetMoney( params.count )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.PROGRESS_BAR ].Repaint = function( self, params )
	local placement = self.wtProgress:GetPlacementPlain()
	--trace( "placement = ", placement )
	
	local toPlacement = CloneTable( placement )
	toPlacement.sizeX = PROGRESS_BAR_LENGTH * params.state / 100
	--trace( "toPlacement = ", toPlacement )
	
	if not self.set then
		self.wtProgress:SetPlacementPlain( toPlacement )
		self.set = true
	else
		self.wtProgress:PlayResizeEffect( placement, toPlacement, 500, EA_MONOTONOUS_INCREASE )
	end
	
	if params.color then
		local color = ReprocessColor( params.color )
		self.widget:SetBackgroundColor( color )
		self.wtProgress:SetBackgroundColor( color )
	end

	self.wtLabel:SetVal( "value", common.FormatInt( params.state, "%d" ) )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.SEPARATOR ].Repaint = function( self, params )
end
--------------------------------------------------------------------------------
-- RESET
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.SMART_LINE ].Reset = function( self )
	self.widget:ClearValues()
	self.widget:SetFormat( GetText( "Default" ) )
	self.widget:SetBackgroundColor( { a = 0, r = 0, g = 0, b = 0 } )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.ICON_SMART_LINE ].Reset = function( self )
	self.wtLabel:ClearValues()
	self.wtLabel:SetFormat( GetText( "Default" ) )
	self.wtLabel:SetBackgroundColor( { a = 0, r = 0, g = 0, b = 0 } )
	
	local placement = self.wtLabel:GetPlacementPlain()
	placement.highPosX = 0
	placement.posX = 0
	self.wtLabel:SetPlacementPlain( placement )
	
	self.wtForeIcon:Show( false )
	self.wtBackIcon:Show( false )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.RUNE_INFO_LINE ].Reset = function( self )
	self.wtLabel:ClearValues()
	self.wtLabel:SetFormat( GetText( "RuneInfoLine" ) )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.DOUBLE_LINE ].Reset = function( self )
	self.wtLeft:ClearValues()
	self.wtRight:ClearValues()
	self.wtLeft:SetFormat( GetText( "Default" ) )
	self.wtRight:SetFormat( GetText( "DefaultRight" ) )
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.ICON_BAR ].Reset = function( self )
	self.container:RemoveItems()
	icons:Clear()
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.MONEY_COUNT ].Reset = money.Reset
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.PROGRESS_BAR ].Reset = function( self )
	local placement = self.wtProgress:GetPlacementPlain()
	placement.sizeX = PROGRESS_BAR_LENGTH
	self.wtProgress:SetPlacementPlain( placement )
	self.set = nil
	self.wtLabel:ClearValues()
end
--------------------------------------------------------------------------------
tooltipcontent[ TOOLTIP_CONTENT.SEPARATOR ].Reset = function( self )
end
--------------------------------------------------------------------------------
-- ICONS
--------------------------------------------------------------------------------
icons.NewWidget = function( self )
	local widget = {}
	
	if not self.widgetDesc then
		widget = mainForm:GetChildChecked( self.name, false )
		self.widgetDesc = widget:GetWidgetDesc()
	else
		widget = mainForm:CreateWidgetByDesc( self.widgetDesc )
	end

	return widget
end
--------------------------------------------------------------------------------
icons.CreateFrom = function( self, widget )
	local set = {}
	set.widget = widget
	set.name = widget:GetName()
	set.widget:Show( false )

	return set
end
--------------------------------------------------------------------------------
icons.GetFree = function( self )
	local id, set = SearchInTable( self.list, { isFree = true } )
	--trace( "id = ", id, ", set = ", set )
	
	if not id then
		set = self:CreateFrom( self:NewWidget() )
		
		set.SetTexture = self.SetTexture
		set.Reset = self.Reset
		
		table.insert( self.list, set )
		id = GetTableSize( self.list )
		set.id = id
		set.name = GetNameByPrefix( set.name, id )
		set.widget:SetName( set.name )
	end
	
	set.isFree = false
	return id, set
end
--------------------------------------------------------------------------------
icons.SetTexture = function( self, texture )
	self.widget:SetBackgroundTexture( texture )
end
--------------------------------------------------------------------------------
icons.Reset = function( self )
	self.widget:SetBackgroundTexture( GetTexture( "Empty" ) )
end
--------------------------------------------------------------------------------
icons.Clear = function( self )
	for id, set in self.list do
		if not set.isFree then
			set.widget:Show( false )
			set:Reset()
			set.isFree = true
		end
	end
end
--------------------------------------------------------------------------------
